//*****************************************************************************************
// Misc Features functions
//*****************************************************************************************

//*****************************************************************************************
function fg_selectUniverse(doc) {

	if (!doc) return;
	if (doc && !fg_isLoginUrl(doc.location.href)) return;	
	if (!fgGetBooleanPref("foxgameSelectUniverse",true)) return;
	
	try {
		var i = fg_loadLogins(doc);	
		if (i == null) return;
		var ele = fg_listaLogins.data[i];
		var uni = ele.uni;
		
		path = '//option[@value="'+uni+'"]';
		var univeroption = fgEval(path,doc);
		
		if (univeroption.snapshotLength != 0) 
			univeroption.snapshotItem(0).selected = true;
		
		var path = '//input[@name="login"]';
		var obj = fgEval(path,doc);
		if (obj.snapshotLength != 0) 
			obj.snapshotItem(0).focus();
			
	} catch(e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addBuildingTime(document) {

	if (document && !fg_isBuildingsUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameBuildingTime",true)) return;

	if (fg_Debug) alert("Estamos tiempo hangar");

	try {
	      var path = '//form/form';
      	var obj = fgEval(path,document);

		if (obj.snapshotLength == 0) return;

		obj = obj.snapshotItem(0);
		while(obj.nodeName != "#text")
			obj = obj.nextSibling;
		var text = obj.nodeValue;
		text = text.split(':');
		if (text.length == 1) //russian patch
		{
			text = text[0].split(/\s+/);
			var text2 = "";
			for (var i = 1; text.length - i > 3; i++) 
				text2 = ' '+ text[text.length - i] + text2;
			text = text2.trim();
		} else 
			text = text[1].trim();
			
		text = text.split(/\s+/);
		var sec = 0, temp = 0;
		for (var i = 0; i < text.length; i++) {	
			text[i]=text[i].replace(/^\s*0(.+)/, "$1");
			temp = fg_parseInt(text[i]);
			if (i == 0 && text.length == 8)
				sec = sec + (temp * 86400);
			else if ((i == 0 && text.length == 6) || (i == 2 && text.length == 8))
				sec = sec + (temp * 3600);
			else if ((i == 0 && text.length == 4) || (i == 2 && text.length == 6) || (i == 4 && text.length == 8))
				sec = sec + (temp * 60);
			else if ((i == 2 && text.length == 4) || (i == 4 && text.length == 6) || (i == 6 && text.length == 8))
				sec = sec + temp;
			i++;
		}
		var date = fg_newDate(document);
        lag = new Number(new Date()) - DOMEventUnloadTime;  // ms / comm+load lag
		date.setTime(date.getTime() + (sec*1000) - lag);		
		var date2 = fg_newDate(document);
	    var text2 = document.createElement('font');
      	text2.textContent = messages.GetStringFromName("foxgame.inner.finishTime") + " : " + fg_formatDate(date,date2);
      	text2.style.color = 'lime';
      	text2.style.fontWeight ='700';
		var br = document.createElement("br");
		obj.parentNode.insertBefore(br,obj.nextSibling);
		obj.parentNode.insertBefore(text2,br.nextSibling);
		
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addResearchTime(document) {

	if (document && !fg_isBuildingsUrl(document.location.href))  return;
	if (!fgGetBooleanPref("foxgameResearchTime",true)) return; 
	
	if (fg_Debug) alert("Estamos tiempo investigacion");

	setTimeout(function(){
		fg_addBxxTime(document,10);
	},500);
}

//*****************************************************************************************
function fg_addBuildingsTime(document) {

	if (document && !fg_isBuildings2Url(document.location.href))  return;
	if (!fgGetBooleanPref("foxgameBuildingsTime",true)) return; 
	
	if (fg_Debug) alert("Estamos tiempo construccion");

	fg_addBxxTime(document,10);
}

//*****************************************************************************************
function fg_addPhalanxTime(document) {

	if (!document || document == null) return;
	if (document && !fg_isPhalanxUrl(document.location.href))  return;
	if (!fgGetBooleanPref("foxgamePhalanxTime",true)) return; 
	
	if (fg_Debug) alert("Estamos tiempo phalanx");
	try {
		var path = '//div[starts-with(@id,"bxx")]';
      	var obj = fgEval(path,document);

		var date, date2 = fg_newDate(document);
		var secs;
		var ele;
		for (var i = 0; i < obj.snapshotLength; i++) {
			ele = obj.snapshotItem(i);
//			secs = fg_parseInt(ele.getAttribute("star"));
			secs = fg_parseInt(ele.getAttribute("title"));
			date = fg_newDate(document);		
			date.setTime(date.getTime() + (secs*1000));			
/*			date = fg_newDate(document);
			var date3 = fg_newDate2(1,fg_getDomain(document));
			date.setTime(date.getTime() - date3.getTime() + (secs*1000));
*/			var text2 = document.createTextNode(fg_formatDate(date,date2));
			var font = document.createElement("font");
			font.setAttribute("color","lime");
			font.appendChild(text2);
			ele.parentNode.appendChild(font);
		}	
	}catch(e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addBxxTime(document,retry) {

	try {
		if (!document ||document == null || document.location == null)
			return;
					
	    var path = '//div[starts-with(@id,"bxx")]';
      	var obj = fgEval(path,document);

		var date, date2 = fg_newDate(document);
		var secs;
		var ele;
		var text;
		for (var i = 0; i < obj.snapshotLength; i++) {
			ele = obj.snapshotItem(i);
			text = ele.firstChild.nodeValue.split(':');
			secs = fg_parseInt(text[0]) * 3600;
			secs = secs + fg_parseInt(text[1]) * 60;
			secs = secs + fg_parseInt(text[2]);

			date = fg_newDate(document);
            var lag   = new Number(new Date()) - DOMEventUnloadTime;  // ms / comm+load lag			
			date.setTime(date.getTime() + (secs*1000) - lag);

			var text2;
			text2 = document.createTextNode(fg_formatDate(date,date2));
			var font = document.createElement("strong");
			font.innerHTML = "<br /><font color='lime'>" +text2.nodeValue+"</font>";
			font.setAttribute("color","lime");
			ele.parentNode.appendChild(font);
		}

	} catch (e) {
		if (retry > 0)
			setTimeout(function(){ fg_addBxxTime(document,retry-1); },5000);		
	}

}

//*****************************************************************************************
function fg_getDelta(document) {

	if (document && !fg_isOverviewUrl(document.location.href)) return;
	
	if (fg_Debug) alert("Estamos obtener delta");

	try {
		var date = new Date();
	      var path = '//table/tbody/tr/th[@colspan="3"][1]';
      	var obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
		obj = obj.snapshotItem(0);
		obj = obj.innerHTML;
		var startTime = getDateFromFormat(obj + " " + (1900+date.getYear()),"E MMM d H:m:s y");
		var lag = new Number(new Date()) - DOMEventUnloadTime;  // ms / comm+load lag	
		fg_Delta = date.getTime() - startTime - lag;		
		PrefsBranchFG.setCharPref("foxgameDeltaTime-"+domain,fg_Delta);
	}catch(e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addOverviewTime(document) {

	if (document && !fg_isOverviewUrl(document.location.href)) return;
	
	if (fg_Debug) alert("Estamos tiempo vision");

	try {
		var path = '//div[starts-with(@id,"bxx")]';
      	var obj = fgEval(path,document);

		var date, date2 = fg_newDate(document);
		var secs;
		var ele;
		for (var i = 0; i < obj.snapshotLength; i++) {
			ele = obj.snapshotItem(i);
/*			if (ele.getAttribute("star") != null && ele.getAttribute("star") != "")
				secs = fg_parseInt(ele.getAttribute("star"));
			else 
*/				secs = fg_parseInt(ele.getAttribute("title"));
			date = fg_newDate(document);
/*			var date3 = fg_newDate2(1,fg_getDomain(document));
			alert(secs*1000);
			date.setTime(date.getTime() - date3.getTime() + (secs*1000));
			alert(date.getTime());
*/          var lag   = new Number(new Date()) - DOMEventUnloadTime;  // ms / comm+load lag			
			date.setTime(date.getTime() + (secs*1000) - lag);
			var text2 = document.createTextNode(fg_formatDate(date,date2));
			var font = document.createElement("font");
			font.setAttribute("color","lime");
			font.appendChild(text2);
			if (ele.getAttribute("class") == "z") {
				if (fgGetBooleanPref("foxgameBuildingsTime",true)) {				
					text = ele.firstChild.nodeValue.split(':');
					secs = fg_parseInt(text[0]) * 3600;
					secs = secs + fg_parseInt(text[1]) * 60;
					secs = secs + fg_parseInt(text[2]);
					date = fg_newDate(document);
            		var lag   = new Number(new Date()) - DOMEventUnloadTime;  // ms / comm+load lag			
					date.setTime(date.getTime() + (secs*1000) - lag);
					font.innerHTML = fg_formatDate(date,date2)						
					ele.parentNode.appendChild(font);
				}					
			} else { 
				if (fgGetBooleanPref("foxgameAddOverviewTime",false)) 
					ele.parentNode.appendChild(font);
				if (fgGetBooleanPref("foxgameRemoveOverviewTime",true))
					ele.parentNode.removeChild(ele);
			}					
		}

	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addRankingButtons(document) {
	return;
	if (document && !fg_isStatUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddStatButtons",false)) return;

	
	if (fg_Debug) alert("Estamos milos ranking");
	
	try {
//Insertamos el .js con la funcion de envio del formulario

	fg_addJavaScript(document, "chrome://foxgame/content/resources/js/milosStat.js");

// Generamos un formulario para enviar la galaxia a MILOS directamente

      var path = '//table[@width="519"]';
      var obj = fgEval(path,document);

	if (obj.snapshotLength < 2) return;
	var i = fg_loadDBs(document);	
	if (i == null) return;
	var ele = fg_listaDBs.data[i];
	var text = "";

	if (ele.type != "GalaxieTool") {
//		obj = obj.snapshotItem(1);
		var Selection = window.getSelection();
		if(Selection.rangeCount > 0) Selection.removeAllRanges();

	     	var range = document.createRange();
	      range.selectNode(obj.snapshotItem(1));
		Selection.addRange(range);

	      var path = '//div[starts-with(@id,"tOoLtIp")]';
      	var obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
		     	var range = document.createRange();
		      range.selectNode(obj.snapshotItem(i));
			Selection.addRange(range);

		}
		texto = Selection.toString();

	} else {
		texto = fg_GTPlugin_getStatsText(document,document.getElementsByName("who")[0].selectedIndex);
		//obj.snapshotItem(1).innerHTML;
		//texto = texto.replace(/'/ig,"");
	}
	

	//Insertamos un formulario para poder enviar los datos directamente.	
	var form = document.createElement('tr');
	var td = document.createElement('td');
	td.setAttribute("colspan","8");
	td.setAttribute("class","1");
	td.setAttribute("align","center");
	td.setAttribute("valign","middle");
	td.innerHTML = fg_MilosDiv;
	if (ele.type == "Milos") {
		if (document.getElementsByName("who")[0].value != "ally") return;
		if (document.getElementsByName("type")[0].value != "pts") return;

		var temp = ele.other.split("[]");
		td.innerHTML += '<form action="http://milos.nethen.org/milos-paste/#" method=post target="_milos" id="milos_form">'+
			'<input type=hidden name="milos_login[user]" value="'+temp[0]+'">'+
			'<input type=hidden name="milos_login[passwd]" value="'+temp[1]+'">'+
			'<input type=hidden name="milos_login[group]" value="'+temp[2]+'">'+
			'<input type=hidden name="milos_login[sg]" value="'+temp[3]+'">'+
			'<input type=hidden name="milos_login[r]" value="">'+
			'<input type=hidden name="show" value="checked">'+
			'<input type=hidden name="noncommit" value="">'+
			'<input type=hidden name="delafter" value="checked">'+
			'<input type=hidden name=x value="'+texto+'">';
	}
	else if (ele.type == "EspRep") {
		if (document.getElementsByName("type")[0].value != "pts") return;

		td.innerHTML += '<form action="http://www.esprep.org/general/dump.php?quick=1" method=post target="_milos" id="milos_form" accept-charset="utf-8">'+
			'<input type=hidden name="show" value="Process Dump (Show Results)">'+
			'<input type="hidden" name="espplayer" value="none">'+
			'<input type="hidden" name="espalliance" value="none">'+
			'<input type=hidden name=dump value="'+texto+'">';
	}
	else if(ele.type == "GalaxieTool") {
			var temp = ele.other.split("[]");
			td.innerHTML += '<form action="'+temp[2]+'" method=post target="_milos" id="milos_form">'+
			//td.innerHTML += '<form action="'+temp[2]+'" method=post target="_blank" id="milos_form">'+
				'<input type=hidden name="user" value="'+temp[0]+'">'+
				'<input type=hidden name="password" value="'+temp[1]+'">'+
				'<input type=hidden name="typ" value="stats">'+
				'<input type=hidden name="who" value="'+document.getElementsByName("who")[0].selectedIndex+'">'+
				'<input type=hidden name="what" value="'+document.getElementsByName("type")[0].selectedIndex+'">'+
				//"<textarea name=content name='content' rows=1 cols=75>"+texto+"</textarea>";
				"<input type=hidden name='content' value='"+texto+"'>";		
	}
	else if(ele.type == "OGSpy") {
			var type = "";
			var temp = document.getElementsByName("type")[0].value;
			if (temp == "pts") type = "general";
			if (temp == "flt") type = "fleet";
			if (temp == "res") type = "research";
			type = type+"_"+document.getElementsByName("who")[0].value;
			td.innerHTML += '<form action="'+ele.other+'" method=post target="_milos" id="milos_form" >'+
				'<input type=hidden name="action" value="get_data">'+
				'<input type="hidden" name="datatype" value="'+type+'">'+
				//'<textarea name=data rows=1 cols=75>'+texto+'</textarea>';
				'<input type=hidden name=data value="'+texto+'">';
	}

	td.innerHTML += "<input type=button value=\"&lt;- "+ele.type+"\" onClick=\"next('l:"+ele.type+"')\">"+
	"<input type=button value=\""+ele.type+"\" onClick=\"next('1:"+ele.type+"')\">"+
	"<input type=button value=\""+ele.type+" -&gt;\" onClick=\"next('r:"+ele.type+"')\">";
		
	form.appendChild(td);

	var tds = fgEval('//table[@width="519"]/child::tbody', document);
	if (tds.snapshotLength > 0)
		tds.snapshotItem(0).insertBefore(form,tds.firstChild);	

	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addAllyButtons(document) {
	return;
	if (document && !fg_isAllyPlayersUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddAllyButtons",true)) return;

	if (fg_Debug) alert("Estamos enviar jugadores de la alianza");
	
	try {

	var i = fg_loadDBs(document);	
	if (i == null) return;
	var ele = fg_listaDBs.data[i];

	//Creamos el Iframe donde se mostraran los resultados de la inclusion
	var div = document.createElement('div');
	div.innerHTML = fg_MilosDiv;

	//Creamos el div donde se meter el formulario
	form = document.createElement('div');

	if (ele.type != "GalaxieTool") return;

      var path = '//table[@width="519"]';
     	var obj = fgEval(path,document);
	if (obj.snapshotLength == 0) return;

	//Creamos la fila donde meter el nuevo boton
	var tr = document.createElement('tr');
	var td = document.createElement('td');
	tr.appendChild(td);
	td.setAttribute("colspan","4");
	td.setAttribute("class","1");
	td.setAttribute("align","center");
	td.setAttribute("valign","middle");

	//Cogemos la tabla de los mensajes y la formateamos para que se pueda meter como input
	var texto = obj.snapshotItem(0).innerHTML;
	texto = texto.replace(/'/ig,"");

	//Creamos el formulario con los datos almacenados
	var temp = ele.other.split("[]");
	form.innerHTML = '<form action="'+temp[2]+'" method=post target="_milos" id="milos_form"  accept-charset="utf-8">'+
		'<input type=hidden name="user" value="'+temp[0]+'">'+
		'<input type=hidden name="password" value="'+temp[1]+'">'+
		'<input type=hidden name="typ" value="allyhistory">'+
		//'<textarea name=content rows=1 cols=75>'+texto+'</textarea>';
		"<input type=hidden name='content' value='"+texto+"'>";

	td.innerHTML += "<input type=button value=\""+ele.type+"\" onClick=\"document.getElementById('milos_form').submit();\">";
	//------------------------------------------

	//Metemos el formulario oculto al final del body con el div del iframe
	fg_appendBody(document,form);	
	form.appendChild(div);
		
	//Buscamos donde meter el nuevo boton y lo metemos
	var tds = fgEval('//table[@width="519"]/child::tbody', document);
	if (tds.snapshotLength > 0)
		tds.snapshotItem(0).insertBefore(tr,tds.snapshotItem(0).firstChild);	
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addFlotaReturnTime(document) {

	if (document && !fg_isFlotaUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaReturnTime",true)) return;

	
	if (fg_Debug) alert("Estamos flota return");

	try {
		try { var mode = fg_parseInt(PrefsBranchFG.getCharPref("fgTimeMode")); } catch (e) { var mode = 1; }
		try { var delta = fg_parseInt(PrefsBranchFG.getCharPref("foxgameDeltaTime-"+fg_getDomain(document))); } catch (e) { var delta = 0; }
		try { if (mode == 3) {
				var diff = 4;
				try { diff = fg_parseInt(PrefsBranchFG.getCharPref("fgTimeDiff")); } catch (e) { ; }
			} else
				diff = 0			
		} catch (e) { var diff = 0; }

		//Aadimos la hora de retorno en caso de retirada
		var date2 = fg_newDate(document);
		var obj = fgEval( '//input[@name="order_return"]', document);
		for ( var i = 0; i < obj.snapshotLength; i++) {
			var date3 = fg_newDate2(mode,fg_getDomain(document));			
			var cell = obj.snapshotItem(i).parentNode.parentNode;
			var startTime = cell.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling;
			startTime = getDateFromFormat(startTime.innerHTML + " " + (1900+date3.getYear()),"E MMM d H:m:s y");
			var date = fg_newDate(document);
			date.setTime(date.getTime() + date3.getTime() - startTime);
			var font = document.createElement('font');
			font.setAttribute('color','lime');
			var div = document.createElement('div');
			div.setAttribute('id',"time_"+i);
			div.innerHTML = fg_formatDate(date,date2);
			font.appendChild(div);
			cell.appendChild(font);
		}
		if (obj.snapshotLength > 0)
		{
			fg_addJavaScript(document,"chrome://foxgame/content/resources/js/dateLibrary.js");
			fg_addJavaScript(document,"chrome://foxgame/content/resources/js/timeFunctions.js");
			fg_loadJs(document,"setTimeout( function() { fg_returnTimeInit('"+mode+"','"+delta+"','"+diff+"','"+fg_getFormatH()+"','"+fg_getFormatD()+"'); } , 250);");
		}
		//	setTimeout(fg_adjustReturnTime,499);
	} catch (e) {
		foxgamedebug(e);
	}
};

//*****************************************************************************************
function fg_addFlota3Time(document) {

	if (document && !fg_isFlota3Url(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaTime",true)) return;

	
	if (fg_Debug) alert("Estamos Flota3 Time");

	try {
		try { var mode = fg_parseInt(PrefsBranchFG.getCharPref("fgTimeMode")); } catch (e) { var mode = 1; }
		try { var delta = fg_parseInt(PrefsBranchFG.getCharPref("foxgameDeltaTime-"+fg_getDomain(document))); } catch (e) { var delta = 0; }
		try { if (mode == 3) {
				var diff = 4;
				try { diff = fg_parseInt(PrefsBranchFG.getCharPref("fgTimeDiff")); } catch (e) { ; }
			} else
				diff = 0			
		} catch (e) { var diff = 0; }

		// Mostramos la hora de retorno y llegada de las naves
		//Insertamos las filas necesarias en la tabla
		var td = fgEval('//table/tbody/tr[@align="left"]/td[@class="c"][@colspan="2"]',document);
		if (td.snapshotLength == 0) 
			return;
		td = td.snapshotItem(0);

		var font = document.createElement('font');
		font.setAttribute('color','lime');
		var text = document.createTextNode(" - ");
		var span = document.createElement('span');
		span.setAttribute('id','llegada1');
		var text2 = document.createTextNode(" - ");
		var span2 = document.createElement('span');
		span2.setAttribute('id','llegada2');
		font.appendChild(text);
		font.appendChild(span);
		font.appendChild(text2);
		font.appendChild(span2);
		td.appendChild(font);

		fg_addJavaScript(document,"chrome://foxgame/content/resources/js/dateLibrary.js");
		fg_addJavaScript(document,"chrome://foxgame/content/resources/js/timeFunctions.js");
		fg_loadJs(document,"setTimeout( function() { fg_timeInit('"+mode+"','"+delta+"','"+diff+"','"+fg_getFormatH()+"','"+fg_getFormatD()+"'); } , 250);");
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addFlotaTime(document) {

	if (document && !fg_isFlota2Url(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaTime",true)) return;

	
	if (fg_Debug) alert("Estamos");

	try {
		try { var mode = fg_parseInt(PrefsBranchFG.getCharPref("fgTimeMode")); } catch (e) { var mode = 1; }
		try { var delta = fg_parseInt(PrefsBranchFG.getCharPref("foxgameDeltaTime-"+fg_getDomain(document))); } catch (e) { var delta = 0; }
		try { if (mode == 3) {
				var diff = 4;
				try { diff = fg_parseInt(PrefsBranchFG.getCharPref("fgTimeDiff")); } catch (e) { ; }
			} else
				diff = 0			
		} catch (e) { var diff = 0; }
		// Mostramos la hora de retorno y llegada de las naves
		//Insertamos las filas necesarias en la tabla

		var node = document.getElementById("duration");

		if (node == null) return;

		node = node.parentNode.parentNode;
		var tr2 = document.createElement('tr');
		tr2.setAttribute("height","20");
		var th2 = new Array(document.createElement('th'), document.createElement('th'));
		th2[0].innerHTML = messages.GetStringFromName("foxgame.inner.arrival2");
		th2[1].innerHTML = "<font color='lime'><div id=\"llegada2\">-</div></font>";

		for (var i=0; i<th2.length; i++)
			tr2.appendChild(th2[i]);

		node.parentNode.insertBefore(tr2,node.nextSibling);
		var tr = document.createElement('tr');
		tr.setAttribute("height","20");
		var th = new Array(document.createElement('th'), document.createElement('th'));
		th[0].innerHTML = messages.GetStringFromName("foxgame.inner.arrival1");
		th[1].innerHTML = "<font color='lime'><div id=\"llegada1\">-</div></font>";
	
		for (var i=0; i<th.length; i++)
			tr.appendChild(th[i]);

		node.parentNode.insertBefore(tr,node.nextSibling);
	

		//Recolocamos el formulario para que el arbol tenga una estructura correcta
	
		var table = fgEval( 
			'//table[@border="0"][@cellpadding="0"][@cellspacing="1"][@width="519"]', document).snapshotItem(0);
		var form = table.firstChild.nextSibling;
		form = table.removeChild(form);

		var input = fgEval( 
			'//input[@name="thisgalaxy"]', document).snapshotItem(0);
		var center = input.parentNode;
		center.parentNode.replaceChild(form,center);
		form.appendChild(center);

		var speed = document.getElementsByName('speed')[0];
		var div = document.createElement('div');
		div.setAttribute('align','right');
		var parent = speed.parentNode;
		while (parent.hasChildNodes()) {
			div.appendChild(parent.firstChild)
		}
		parent.appendChild(div);
		//Llamamos a la funcion que actualiza el tiempo
		//fg_adjustTime();

		fg_addJavaScript(document,"chrome://foxgame/content/resources/js/dateLibrary.js");
		fg_addJavaScript(document,"chrome://foxgame/content/resources/js/timeFunctions.js");
		fg_loadJs(document,"setTimeout( function() { fg_timeInit('"+mode+"','"+delta+"','"+diff+"','"+fg_getFormatH()+"','"+fg_getFormatD()+"'); } , 250);");
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addLabels(document) {
	if (document && !fg_isFlota3Url(document.location.href)) return;
	try {
	      var path = '//input[@name="order"]';
     		var obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj2 = obj.snapshotItem(i);
			var label = document.createElement('label');
			label.appendChild(obj2.parentNode.removeChild(obj2.nextSibling));
			obj2.parentNode.insertBefore(label, obj2.nextSibling);
			obj2.setAttribute('id','inpuT_'+i);
			label.setAttribute('for','inpuT_'+i);
		}
	} catch(e) {
		foxgamedebug(e);
	}
}


//*****************************************************************************************
function fg_selectMission(document) {

	function fg_getPref(pref) {
		try {
			return PrefsBranchFG.getCharPref(pref)
		} catch(e) {
			return "-1";
		}
	}
	if (document && !fg_isFlota3Url(document.location.href)) return;

	var pref = fg_getPref("fgMissionPreference0");

	if (pref == "-1") return;
	if (fg_Debug) alert("Estamos mission select");

	try {
	      var path = '//input[@name="order"][@checked="checked"]';
     		var obj = fgEval(path,document);
		if (obj.snapshotLength != 0) return;
		var i = 0;
		while(pref != "-1") {
		      path = '//input[@name="order"][@value="'+pref+'"]';
      		obj = fgEval(path,document);
			if (obj.snapshotLength != 0) {
				obj = obj.snapshotItem(0);
				obj.checked = "true";
				return;
			}
			i++;
			pref = fg_getPref("fgMissionPreference"+i);
		}
		return;
	} catch(e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_pasteCoords(document) {

	if (document && document != null && !fg_isFlota2Url(document.location.href)) return;

	if (!document.getElementsByName("galaxy")[0] || !document.getElementsByName("thisgalaxy")[0]) return; 

	if (!fgGetBooleanPref("foxgameAutoCopy",false)) return;
	if (!fgGetBooleanPref("foxgameStoreCoordFlag",false)) return;

	if (fg_Debug) alert("Estamos pegar coordenadas");
	try {
		var str = PrefsBranchFG.getCharPref("foxgameStoreCoord");
	} catch(e) { return;}

	try {
		str = str.split(':');
		fg_Galaxy = str[0];
		fg_System = str[1];
		fg_Planet = str[2];
	
		if (document.getElementsByName("galaxy")[0].value == document.getElementsByName("thisgalaxy")[0].value && document.getElementsByName("system")[0].value == document.getElementsByName("thissystem")[0].value && document.getElementsByName("planet")[0].value == document.getElementsByName("thisplanet")[0].value) {
			document.getElementsByName("galaxy")[0].value = fg_Galaxy;
			document.getElementsByName("system")[0].value = fg_System;
			document.getElementsByName("planet")[0].value = fg_Planet;
		}
	} catch(e) {
		foxgamedebug(e);
	}
}

//****************************************************************************************
function fg_addPlanetButtons(document) {

   if (!document) return;
   if (!fgGetBooleanPref("foxgamePlanetButtons",true)) return;  

   if (fg_Debug) alert("Botones << et >>");
   
   try {
      var path = '//select[starts-with(@onchange,"haha(this)")]/option';
      var option = fgEval(path,document); 
      if (option.snapshotLength < 1)
		return;
          
       //search the id of the curent planet
       var eleSelectedId;
       for (eleSelectedId=0;option.snapshotItem(eleSelectedId).selected == false;eleSelectedId++) {}
	
       //insert the "previous" button
       var input = document.createElement("input");
       input.setAttribute("value","<<");
       input.setAttribute("type","submit");
       input.setAttribute("onclick","eval(location='" + option.snapshotItem((eleSelectedId+(option.snapshotLength-1))%option.snapshotLength).value + "');");
       
            
        //insert the "next" button
        var input2 = document.createElement("input");
        input2.setAttribute("value",">>");
        input2.setAttribute("type","submit");
        input2.setAttribute("onclick","eval(location='" + option.snapshotItem((eleSelectedId+1)%option.snapshotLength).value + "');");
        var center = document.createElement("center");
        center.appendChild(input);
        center.appendChild(document.createTextNode(" "));
        center.appendChild(input2);
        option.snapshotItem(0).parentNode.parentNode.insertBefore(center,option.snapshotItem(0).parentNode.nextSibling);
   } catch (e) {
      foxgamedebug(e);
   }
} 

//*****************************************************************************************
function fg_addPhalanxRange(document) {

   if (document && !fg_isBuildings2Url(document.location.href)) return;
   if (!fgGetBooleanPref("foxgamePhalanxRangeInfo",true)) return;
      
   if (fg_Debug) alert("fg_addPhalanxRange");

   try {
	var path = '//td[@class="l"][2]/a[contains(@href,"gid=42")]/following-sibling::text()';
    var obj = fgEval(path,document);
	if (obj.snapshotLength == 0)
		return;
	var obj = obj.snapshotItem(0);
	var html = obj.nodeValue;
   	var results = html.substring(html.indexOf('('),html.indexOf(')')).replace(/[\D]/ig,'')||0;		
	if (results == 0) 
		return;
	results = fg_parseInt(results);
	results = Math.pow(results,2) - 1;
    path = '//select[starts-with(@onchange,"haha(this)")]';
    option = fgEval(path,document);
	if (option.snapshotLength == 0)
		return;
	var text = option.snapshotItem(0).options[option.snapshotItem(0).selectedIndex].text;
	text = text.match(/\[[0-9\:]+\]/g);
	text = text[0].split(':')[0].substring(1);
	var range1 = (results+fg_parseInt(text));	
	var range2 = fg_parseInt(text)-results;
	if (range2 < 1)
		range2 = 1;
	if (range1 > 499)	
		range1 = 499;
	range1 = text[0]+":"+range1;
	range2 = text[0]+":"+range2;
	var br = document.createElement('br');
    var font = document.createElement("font");
	font.setAttribute("color","orange");
    font.setAttribute("size","smaller");
	var span = document.createElement("span");
    span.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;" + range2+" - "+range1;
    span.setAttribute("class","range");
    font.appendChild(span);
	obj.parentNode.insertBefore(font, obj.nextSibling);
	//obj.parentNode.appendChild(font);
   } catch (e) {
      foxgamedebug(e);
   }
}

//*****************************************************************************************
function fg_addRankDiff(document) {  //Original code from Coup de Grace

   	if (document && !fg_isStatUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameShowRankDiffs",true)) return;   	

   	try {
    	var path = '//table/tbody/tr/th/a';
      	var obj = fgEval(path,document);
      	if (obj.snapshotLength == 0) return;
      	for (var i = 0; i < obj.snapshotLength; i++) {
        	var obj2 = obj.snapshotItem(i);
         	var mouseover = obj2.getAttribute("onmouseover");
         	if (mouseover != null && mouseover.length > 0) {
            	var startfont = mouseover.indexOf('<');
            	var endfont = mouseover.indexOf('<br/>');
            	if (startfont != -1 && endfont != -1) {
               		var diff = mouseover.substr(startfont, endfont);
               		obj2.innerHTML = diff.replace(/\\/g, "");
            	}
         	}
      	}
    	var path = '//table/tbody/tr/td[1][@class="c"][@width="30"]';
    	var obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
			obj.snapshotItem(0).removeAttribute('width');
   	} catch (e) {
    	foxgamedebug(e);
   	}
}

//*****************************************************************************************
function fg_setFocus(document) {

	if (document && document != null
		&& !(fg_isFlota2Url(document.location.href) && fgGetBooleanPref("foxgameSetFocus",true))
		 && !(fg_isFlota3Url(document.location.href) && fgGetBooleanPref("foxgameSetFocus",true))) return;

	if (fgGetBooleanPref("foxgameSetFocus",true)) { 
		var path = '//input[@type="submit"]';
		var obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) 
			if (obj.snapshotItem(i).form != null && obj.snapshotItem(i).form.action != null && obj.snapshotItem(i).form.action.indexOf('index.php') > 0)
				obj.snapshotItem(i).focus();
	} else {
		var path = '//form[contains(@action,"index.php")]/descendant::*/input[not(@type)]|//input[@type="radio"]';
		var obj = fgEval(path,document);
		if (obj.snapshotLength > 0) 
			obj.snapshotItem(0).focus();
	}
}


//*****************************************************************************************
function fg_setAKey(document) {

	if (document && !fg_isFlota2Url(document.location.href) && !fg_isFlota3Url(document.location.href)
	&& !fg_isBuildingsUrl(document.location.href) && !fg_isBuildings2Url(document.location.href)
	&& !fg_isWriteMessagesUrl(document.location.href)) return;

	if (!fgGetBooleanPref("foxgameSetAccessKey",false)) return;
	
	var key = '';
	try { 
		key = PrefsBranchFG.getCharPref("foxgameAccessKey");
	} catch (e) { 
		return;
	}
	var path = '//input[@type="submit"]';
	var obj = fgEval(path,document);
	if (obj.snapshotLength > 0 && key != '') 
		obj.snapshotItem(0).setAttribute('accessKey',key);
}

//*****************************************************************************************
function fg_reduceDescriptions(document) {

   	if (!document) return;
	if (!fgGetBooleanPref("foxgameReducedSDR",false) &&  fg_isBuildingsUrl(document.location.href)) 
		return;
	else if (!fgGetBooleanPref("foxgameReducedB",false) &&  fg_isBuildings2Url(document.location.href)) 
		return;
	else if (!fg_isBuildingsUrl(document.location.href) && !fg_isBuildings2Url(document.location.href))
		return;
			
	if (fg_Debug) alert("fg_reduceDescriptions");

   	try {
    	var path = "//td[@class='l']/a/img[1]/../..";
        var obj = fgEval(path,document);
      	var cell;         
        for (var i = 0; i < obj.snapshotLength; i++) {
        	cell = obj.snapshotItem(i);
            cell.setAttribute('style','display:none');
            cell.parentNode.removeChild(cell);
        }
        path = "//td[@class='l']/br[1]";
        obj = fgEval(path,document);
        for (var i = 0; i < obj.snapshotLength; i++) {
        	cell = obj.snapshotItem(i);
      		if (cell.nextSibling != null)
        		cell.parentNode.removeChild(cell.nextSibling);
      		cell.parentNode.setAttribute('colspan','2');               
      		cell.parentNode.removeChild(cell);
        }
   } catch (e) {
      foxgamedebug(e);
   }
}

//*****************************************************************************************
function fg_showEnergyResources(document) {
   	if (!document) return;
	if (!fg_isResourcesUrl(document.location.href))
		return;

	if (!fgGetBooleanPref("foxgameShowEnergyResources",false)) return;
			
	if (fg_Debug) alert("fg_energyResources");

   	try {
   		// retrives energy - dark mater safe
   		var path = '//table[@id="resources"]/tbody/tr[3]/td/font';
    	var obj = fgEval(path,document);
    	if (obj.snapshotLength == 0)
    		return;
    	energyText = fg_parseInt(obj.snapshotItem(obj.snapshotLength-1).textContent.replace(/[\.]/gi,''));

   	
        obj = fgEval('//table[@width="550"]/descendant::tr[4]',document);
		if (obj.snapshotLength == 0)
			return;	
		var initText = "";
		var tr = obj.snapshotItem(0);	
		while (tr != null) {
			if (tr.childNodes.length < 7)
				break;
			var Energy, Current;		
			var isSolar = false;
			var consume = true;
			var th = fgEvalnode('./th[1]',document,tr);
			var text = th.snapshotItem(0).innerHTML.split('(');

			text = text[1].split(' ');
			var prevText = text[text.length -2];			
			if (initText != "" && initText == prevText)
				 isSolar = true;
			text = text[text.length - 1];
	        var Level = text.substr(0,text.length -1);
			th = fgEvalnode('./th[7]/descendant::select',document,tr);		
			Current = th.snapshotItem(0).value;
		
			var obj = fgEvalnode('./th[3]/descendant::font[@color="#00ff00"]',document,tr);
							
			if (obj.snapshotLength > 0) {  //Metal
				Energy = Math.ceil(10 * Level * Math.pow(1.1,Level));
				initText = prevText;
			} else {	
				obj = fgEvalnode('./th[4]/descendant::font[@color="#00ff00"]',document,tr);
				if (obj.snapshotLength > 0) { //Crystal
					Energy = Math.ceil(10 * Level * Math.pow(1.1,Level));
					initText = prevText;
				} else {		
					obj = fgEvalnode('./th[5]/descendant::font[@color="#00ff00"]',document,tr);
					if (obj.snapshotLength > 0) { //Deut
						Energy = Math.ceil(20 * Level * Math.pow(1.1,Level));
						initText = prevText;
					} else {		
						obj = fgEvalnode('./th[5]/descendant::font[@color="#ff0000"]',document,tr);
						if (obj.snapshotLength > 0) { //Fusion
							//alert("hi2");
							var ELevel = fg_getEnergyLevel(document);
							if (ELevel == 0) {
								tr = tr.nextSibling.nextSibling;
								continue;
							}				
							Energy = parseInt(30 * Level * Math.pow(1.05 + (0.01*ELevel),Level));
							initText = prevText;
							consume = false;
						} else if (isSolar) {
							Energy = parseInt(20 * Level * Math.pow(1.1,Level));
							consume = false;
						} else {
							th = fgEvalnode('./th[6]/descendant::font[@color="#00ff00"]',document,tr);
							if (th.snapshotLength < 1) {
								tr = tr.nextSibling.nextSibling;
								continue;							
							}
							Energy = fg_parseInt(th.snapshotItem(0).innerHTML);
							th = fgEvalnode('./th[7]/descendant::select',document,tr);		
        					Energy = Energy * 100/th.snapshotItem(0).value;
        					consume = false;        							
						}				
					}
				}		
			}				
			th = fgEvalnode('./th[7]/descendant::option',document,tr);
			var TotalEnergy
			if (consume == false)
				TotalEnergy = energyText - Math.round((Energy / 100) * Current);
			else				
				TotalEnergy = energyText + Math.round((Energy / 100) * Current);
							
			for (var i = 0; i < th.snapshotLength; i++) {
				var opt = th.snapshotItem(i);
				if (consume == false)
					opt.innerHTML = opt.innerHTML + " " + Math.floor((Energy / 100) * opt.value) + " (" + (TotalEnergy + Math.round((Energy / 100) * opt.value)) +")";
				else					 
					opt.innerHTML = opt.innerHTML + " " + Math.ceil((Energy / 100) * opt.value) + " (" + (TotalEnergy - Math.round((Energy / 100) * opt.value)) +")";				
			}
			th = fgEvalnode('./th[2]',document,tr);
			if (th.snapshotItem(0).innerHTML.indexOf("<img") == -1) {
				th.snapshotItem(0).parentNode.removeChild(th.snapshotItem(0));
				th = fgEvalnode('./th[1]',document,tr);
				th.snapshotItem(0).setAttribute("colspan","2");
			}
			tr = tr.nextSibling.nextSibling;
		}
   	} catch (e) {
    	foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_processEnergyLevel(document) {
   	if (!document) return;
	if (!fg_isBuildingsUrl(document.location.href))
		return;
	try {
		var path ='//td[@class="l"][2]/a[contains(@href,"gid=113")]/following-sibling::text()';
    	var obj = fgEval(path,document);    	
    	if (obj.snapshotLength == 0)
    		return;
		var html = obj.snapshotItem(0).nodeValue;
    	var level = html.substring(html.indexOf('('),html.indexOf(')')).replace(/[\D]/ig,'')||0;
		EnergyLevels[document.location.host] = level;    	
	} catch (e) {
    	foxgamedebug(e);
	}    
}


//*****************************************************************************************
// Code from SA, Cezarica and my own
//*****************************************************************************************
function fg_addEnergyStatus(document) {
	if (document && !fg_isBuildings2Url(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameShowEnergyInfo",true)) return;
	try {
   		// retrives energy - dark mater safe
   		var path = '//table[@id="resources"]/tbody/tr[3]/td/font';
    	var obj = fgEval(path,document);
    	if (obj.snapshotLength == 0)
    		return;    	
    	var energy = fg_parseInt(obj.snapshotItem(obj.snapshotLength-1).textContent.replace(/[\.]/gi,''));
		path = '//table[@id="resources"]/tbody/tr[2]/td/descendant::font';
    	obj = fgEval(path,document);
    	energyText = obj.snapshotItem(obj.snapshotLength-1).textContent;

   		// retrive buildings
    	var path = '//tr/child::td[2]/child::a';
    	var obj = fgEval(path,document);
    	for (var i=0; i<obj.snapshotLength; i++) {
      		var obj2  = obj.snapshotItem(i);                            // building row
      		var gid   = obj2.href.replace(/.*gid=([\d]+).*/i,'$1');  // building id
      		var text  = obj2.parentNode.textContent;                    // building text
      		var level = 0;                                              // will be filled with level
      		var result= null;                                           // result energy

      		if (text.indexOf('(')>0) // read level
      			level = fg_parseInt(text.substring(text.indexOf('('),text.indexOf(')')).replace(/[\D]/gi,''))||0;
      		if(gid==1||gid==2)        // Metal Mine & Crystal Mine
      			result= - (Math.ceil(10*(level+1)*Math.pow(1.1,(level+1)))- Math.ceil(10*level*Math.pow(1.1,level)));

      		if(gid==3) // Deuterium Synthesizer
      			result= - (Math.ceil(20*(level+1)*Math.pow(1.1,(level+1)))- Math.ceil(20*level*Math.pow(1.1,level)));

      		if(gid==4) // Solar Plant
      			result= Math.floor(20*(level+1)*Math.pow(1.1,(level+1)))- Math.floor(20*level*Math.pow(1.1,level));


			if(gid==12){ // Fusion Reactor
				var ELevel = fg_getEnergyLevel(document)
				if (ELevel != 0)
      				result= Math.floor(30*(level+1)*Math.pow(1.05+0.01*ELevel,(level+1)))- Math.floor(30*(level)*Math.pow(1.05+0.01*ELevel,(level)));
      			else
      				result = null;
			}
			
      		if(result!=null) { // if result, add energy status
      			var ending = energy + result;
        		var span = document.createElement("span");
        		span.setAttribute("class","energyInfo");
        		span.innerHTML= "&nbsp;&nbsp;&nbsp;&nbsp;" + energyText + ': <font color="'
        		+(result>0?'lime':'red')+'">'+(result>0?'+':'')+result+'</font>(<b><font color="'
        		+(ending>0?'lime':'red')+'">'+(ending>0?'+':'')+ending+'</font></b>)';
        		if (obj2.nextSibling.nodeName.toLowerCase() == "br")
        			obj2.parentNode.insertBefore(span,obj2.nextSibling);
        		else
        			obj2.parentNode.insertBefore(span,obj2.nextSibling.nextSibling);
      		}
      		if (gid == 12) break; // no more buildings needed
    	}
    } catch (e) {
    	foxgamedebug(e);
  	} 	  	
} 
//*****************************************************************************************
// Code from SA, Cezarica and my own
//*****************************************************************************************
function fg_addMaxResFloTranspButton(document) {
	if (document && !fg_isFlotaUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameShowCargoNeeded",true)) return;
  	if (fg_Debug) alert("fg_addMaxResFloTranspButton");
  	try {
    	// get metal, crystal & deuterium
    	var obj  = fgEval('//table[@id="resources"]/tbody/tr[3]/td',document);
    	if (obj.snapshotLength < 3)
    		return;
    	var sum = fg_parseInt(obj.snapshotItem(0).textContent.replace(/[\D]/gi,''))
             + fg_parseInt(obj.snapshotItem(1).textContent.replace(/[\D]/gi,''))
             + fg_parseInt(obj.snapshotItem(2).textContent.replace(/[\D]/gi,''));

    	// number of ships
    	var num_ship = new Array();
    	num_ship[202] = Math.ceil(sum/5000); // small cargo
    	num_ship[203] = Math.ceil(sum/25000); // large cargo
    	num_ship[208] = Math.ceil(sum/7500); // colony ship
    	num_ship[209] = Math.ceil(sum/20000); // recycler
    	num_ship[214] = Math.ceil(sum/1000000); // deathstar

    	for (var shipid in num_ship) {
      		var path_ship = '//a[starts-with(@href,"javascript:maxShip(\'ship'+shipid+'\');")]';
      		var ship = fgEval(path_ship,document);
      		if (ship.snapshotLength > 0) {
      			var red = false;
      			ship = ship.snapshotItem(0);
      			path_ship = '//input[@name="maxship'+shipid+'"][@value<'+num_ship[shipid]+']';  			
   				if (fgEval(path_ship,document).snapshotLength > 0 )
   					red = true;;
        		var ship_a = document.createElement("a");
        		ship_a.setAttribute("href","#");
        		ship_a.setAttribute("onClick","document.getElementsByName('ship"+shipid+"')[0].value="+num_ship[shipid]+";");
        		
        		if (fgGetBooleanPref("foxgameShowFleetCargo",true))
        			ship_a.setAttribute("onClick",ship_a.getAttribute("onClick") + "ShowCapacity();");
        			
        		if (red)
        			ship_a.innerHTML = "<font color='red'>("+num_ship[shipid]+")</font>";
        		else
        			ship_a.innerHTML = "("+num_ship[shipid]+")";
        		ship.parentNode.appendChild(ship_a);
      		}
    	}
    } catch (e) {
    	foxgamedebug(e);
  	}
}  
//*****************************************************************************************
// Code from SA
//*****************************************************************************************	
function fg_showProdPercent(document){
  	if (!document) return;  // no url check
  	if (document && !fg_isBuildings2Url(document.location.href) 
  		&& !fg_isResearchUrl(document.location.href)) return;

	if (!fgGetBooleanPref("foxgameShowProdPercent",true)) return;

	fg_addJavaScript(document,"chrome://foxgame/content/resources/js/anon_prodpercent.js");
}
//*****************************************************************************************
// Code from SA
//*****************************************************************************************	
function fg_showFleetCargo(document){
  	if (!document) return;  // no url check
  	if (document && !fg_isFlotaUrl(document.location.href)) return;

	if (!fgGetBooleanPref("foxgameShowFleetCargo",true)) return;

	fg_addJavaScript(document,"chrome://foxgame/content/resources/js/anon_fleet1.js");
}	